/* $Id: findORF.c,v 2.1.1.1 2004/08/12 15:20:17 roman Exp $ */
/* written by Roman R. Stocsits, 2004 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

extern struct SEQdata *SEQ;

void findORF(void);
void infoFile(void);
void EditFile(void);
void makePS(short id);
char *translateORF(char *orf, char *CodonTableName);

/*--------------------------------------------------------------------------*/

void findORF(void){

  struct CDSdata *found=NULL;
  short r=0, w=0, l=0, mi=0, ac=0, te=0, eu=0, my=0;
  long len, i, j, ORFlength, x=0, a=0, min_len=0;
  char *foundORF=NULL, *line;
  FILE *edit;

  edit = fopen("edit.ral", "r");
  if(!edit){
      fprintf(stderr, " *\nCould not open temporary parameter file 'edit.ral'.\nAborting.\n *\n");
      exit(80);
  }
  line=get_line(edit);
  if(line[0]=='[')    sscanf(line, "%*s %*s %*s %*s %*s %*s %li", &min_len);
  free(line);
  fclose(edit);
  
  while(SEQ[r].seq){
    len=SEQ[r].len;
    found=(struct CDSdata*)space(120*sizeof(struct CDSdata));
    for(w=0; w<120; w++){
      found[w].join=0;
      found[w].start=0;
      found[w].stop=0;
      found[w].weight=0;
      found[w].AAseq=NULL;
      found[w].joinedSeq=NULL;
    }
    w=0;
    if(!strcmp(SEQ[r].CTN,"mitovrt"))  mi=1;
    if(!strcmp(SEQ[r].CTN,"acet"))  ac=1;
    if(!strcmp(SEQ[r].CTN,"tepa"))  te=1;
    if(!strcmp(SEQ[r].CTN,"eupl"))  eu=1;
    if(!strcmp(SEQ[r].CTN,"mysp"))  my=1;
    for(i=0; i<len-3; i++){
      if(SEQ[r].seq[i]=='A'){
	if((SEQ[r].seq[i+1]=='T')||(SEQ[r].seq[i+1]=='U')){
	  if(SEQ[r].seq[i+2]=='G'){
	    found[w].start=i+1;
	    for(j=i+3; j<len; j+=3){
	      if((((mi)&&((SEQ[r].seq[j]=='A')&&(SEQ[r].seq[j+1]=='G')&&
			  ((SEQ[r].seq[j+2]=='A')||(SEQ[r].seq[j+2]=='G')))))||
		 (((SEQ[r].seq[j]=='T')||(SEQ[r].seq[j]=='U'))&&
		  (((SEQ[r].seq[j+1]=='G')&&(SEQ[r].seq[j+2]=='A'))||
		   ((SEQ[r].seq[j+1]=='A')&&
		    ((SEQ[r].seq[j+2]=='A')||(SEQ[r].seq[j+2]=='G')))))){
		if((ac)||(te)){
		  if((SEQ[r].seq[j+1]=='A')&&
		     ((SEQ[r].seq[j+2]=='A')||(SEQ[r].seq[j+2]=='G'))){
		    continue;
		  }
		}
		if(((eu)||(my))||
		   (!strncmp(SEQ[r].CTN,"mito",4))){
		  if((SEQ[r].seq[j+1]=='G')&&(SEQ[r].seq[j+2]=='A')){
		    continue;
		  }
		}
		found[w].stop=j+3;
		w++;
		if(min_len){
		  if((found[w-1].stop-found[w-1].start+1)<min_len){
		    found[w-1].stop=0;
		    found[w-1].start=0;
		    w--;
		  }
		}
		else  if(((found[w-1].stop-found[w-1].start+1)<SEQ[r].len/15)&&
			 ((found[w-1].stop-found[w-1].start+1)<300)){
		  found[w-1].stop=0;
		  found[w-1].start=0;
		  w--;
		}
		else if(w-1){ 
		  for(l=0;l<w-1;l++){
		    if(found[w-1].stop==found[l].stop){
		      w--;
		      found[w].start=0;
		      found[w].stop=0;
		      break;
		    }
		  }
		}
		break;
	      }
	    }
	  }
	}
      }
    }
    found[w].start=0;
    SEQ[r].found=found;
    
    w=0;
    while(SEQ[r].found[w].start){
      ORFlength = SEQ[r].found[w].stop - SEQ[r].found[w].start +1;
      foundORF=(char*)space((ORFlength+1)*sizeof(char));
      x=0;
      for(a=(SEQ[r].found[w].start-1); a < SEQ[r].found[w].stop; a++){
	foundORF[x] = SEQ[r].seq[a];
	x++;
      }
      foundORF[x] = '\0';
      SEQ[r].found[w].AAseq = (char*)space(((ORFlength+1)/3+1)*sizeof(char));
      strcpy(SEQ[r].found[w].AAseq, translateORF(foundORF, SEQ[r].CTN));
      free(foundORF);
      w++;
    }
    w=0;
    r++;
  }
}

/*--------------------------------------------------------------------------*/

void infoFile(void){
  
  unsigned short q=0, w=0;
  FILE *info;

  info=fopen("info.ral", "w");
  while(SEQ[q].seq){
    fprintf(info,"File name: %s\n", SEQ[q].FN);
    fprintf(info,"Codon Table: %s\n", SEQ[q].CTN);
    fprintf(info,"Sequence name: > %s   [%ibp]   Number: %i\n",
	    SEQ[q].seqname, SEQ[q].len, SEQ[q].no);
    fprintf(info,"GenBank file information derived exons, if available:\n");
    if(SEQ[q].exon[w].start){
      fprintf(info,"  START - STOP:\n");
      while(SEQ[q].exon[w].start){
	fprintf(info,"  %li - %li\n", SEQ[q].exon[w].start, SEQ[q].exon[w].stop);
	w++;
      }
    }
    else fprintf(info, "  no exons\n");
    w=0;
    fprintf(info,"GenBank file derived CDS marked open reading frames:\n");
    if(SEQ[q].ORF[w].start){
      fprintf(info,"  START - STOP:\n");
      while(SEQ[q].ORF[w].start){
	fprintf(info,"  %li - %li\n", SEQ[q].ORF[w].start, SEQ[q].ORF[w].stop);
	w++;
      }
    }
    else fprintf(info, "  Could not read GenBank file information.\n");
    w=0;
    fprintf(info,"Open reading frames derived by codaln automatic search:\n");
    if(SEQ[q].found[w].start){
      fprintf(info,"  START - STOP:\n");
      while(SEQ[q].found[w].start){
	fprintf(info,"  %li - %li\n", SEQ[q].found[w].start, SEQ[q].found[w].stop);
	w++;
      }
    }
    else fprintf(info, "  No open reading frames found.\n");
    fprintf(info,"\n");
    q++;
    w=0;
  }
  fclose(info);
}

/*--------------------------------------------------------------------------*/

void EditFile(void){
  
  unsigned short q=0, w=0;
  FILE *edit;

  edit=fopen("edit.ral", "a");
  fprintf(edit,"DO NOT FORGET TO RENAME THIS FILE AFTER EDITING!\n\n");
  while(SEQ[q].seq){
    fprintf(edit,"> %s  [%ibp]  file: %s  ctn=%s  No. %i\n",
	    SEQ[q].seqname, SEQ[q].len, SEQ[q].FN, SEQ[q].CTN, SEQ[q].no);

 fprintf(edit,"exon table (START -> STOP -> WEIGHT -> JOIN):\n");
    if(SEQ[q].exon[w].start){
      while(SEQ[q].exon[w].start){
	fprintf(edit,"  %li  %li  1  %hi\n", SEQ[q].exon[w].start, SEQ[q].exon[w].stop, 
		SEQ[q].exon[w].join);
	w++;
      }
    }
    else fprintf(edit, "  none\n");
    w=0;
    fprintf(edit,"open reading frame table (START -> STOP -> WEIGHT -> JOIN):\n");
    if(SEQ[q].ORF[w].start){
      while(SEQ[q].ORF[w].start){
	fprintf(edit,"  %li  %li  1  %hi\n", SEQ[q].ORF[w].start, SEQ[q].ORF[w].stop,
		SEQ[q].ORF[w].join);
	w++;
      }
    }
    else fprintf(edit, "  none\n");
    w=0;
    fprintf(edit,"open reading frame table (beta group) (START -> STOP -> WEIGHT):\n");
    if(SEQ[q].found[w].start){
      while(SEQ[q].found[w].start){
	fprintf(edit,"  %li  %li  1\n", SEQ[q].found[w].start, SEQ[q].found[w].stop);
	w++;
      }
    }
    else fprintf(edit, "  none\n");
    fprintf(edit,"--end of sequence entry--\n");
    q++;
    w=0;
  }
  fprintf(edit,"\nDO NOT FORGET TO RENAME THIS FILE AFTER EDITING!\n\n");
  fclose(edit);
}
/*--------------------------------------------------------------------------*/

void makePS(short id){

  FILE *ps=NULL;
  char *date;
  short a=0, b, c=0, d;
  
  if(id == 1)   ps=fopen("ORF.ps","w");
  if(id == 2)   ps=fopen("ORF_edit.ps","w");
  if((id!=1) && (id!=2)){
    fprintf(stdout, "Bad internal error. Aborting.\n");
    exit(80);
  }
  date=time_stamp(); 

  
  fprintf(ps,"%%!PS-Adobe-2.0 EPSF-1.2\n");
  fprintf(ps,"%%%%Creator: codaln\n");
  fprintf(ps,"%%%%CreationDate: %s", date);
  fprintf(ps,"%%%%Title: open reading frames\n");
  fprintf(ps,"%%%%BoundingBox: 42 26 528 777\n");
  fprintf(ps,"%%%%DocumentFonts: Helvetica\n");
  fprintf(ps,"%%%%Pages: 1\n");
  fprintf(ps,"%%%%EndComments\n\n");
  fprintf(ps,"/Log2 {2 log} bind def\n");
  fprintf(ps,"/Log5 {5 log} bind def\n");
  fprintf(ps,"/labelswitch 1 def\n");
  fprintf(ps,"/legendswitch 1 def\n");
  fprintf(ps,"/Xsize 400 def\n");
  fprintf(ps,"/Ysize 700 def\n");
  fprintf(ps,"/BoxYsize 10 def\n");
  fprintf(ps,"/GrayValue .6 def\n\n");
  fprintf(ps,"/ChangeGrayValue { %% newvalue ChangeGrayValue -\n");
  fprintf(ps,"  /GrayValue exch def\n");
  fprintf(ps,"} bind def\n\n");
  fprintf(ps,"/labelshow {\n");
  fprintf(ps,"  labelswitch 1 eq {\n");
  fprintf(ps,"    dup stringwidth\n");
  fprintf(ps,"    pop\n");
  fprintf(ps,"    BoxYsize 2 div\n");
  fprintf(ps,"    add neg\n");
  fprintf(ps,"    0 0 moveto\n");
  fprintf(ps,"    0 rmoveto\n");
  fprintf(ps,"    show\n");
  fprintf(ps,"  }{}ifelse\n");
  fprintf(ps,"} bind def\n\n");

  fprintf(ps,"/legendshow {\n");
  fprintf(ps,"  legendswitch 1 eq {\n");
  fprintf(ps,"   0 -100 moveto\n");
  fprintf(ps,"   40 0 rlineto\n");
  fprintf(ps,"   0 10 rlineto\n");
  fprintf(ps,"   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n");
  fprintf(ps,"   0.6 setgray fill\n");
  fprintf(ps,"   stroke\n");
  fprintf(ps,"   0 -100 moveto\n");
  fprintf(ps,"   0 setgray\n");
  fprintf(ps,"   1 setlinewidth\n");
  fprintf(ps,"   40 0 rlineto\n");
  fprintf(ps,"   0 10 rlineto\n");
  fprintf(ps,"   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n   stroke\n");
  fprintf(ps,"   50 -100 moveto\n");
  fprintf(ps,"   (complete nucleic acid sequence) show\n");
  fprintf(ps,"   0 -120 moveto\n");
  fprintf(ps,"   40 0 rlineto\n   0 10 rlineto\n   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n   0.1 setgray fill\n   stroke\n");
  fprintf(ps,"   0 -120 moveto\n   0 setgray\n   1 setlinewidth\n");
  fprintf(ps,"   40 0 rlineto\n   0 10 rlineto\n   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n   stroke\n   50 -120 moveto\n");
  if(id == 1) fprintf(ps,"   (GenBank file derived exons and open reading frames) show\n");
  if(id == 2) fprintf(ps,"   (exons or open reading frames after editing (group with higher priority)) show\n");
  fprintf(ps,"   0 -138 moveto\n");
  fprintf(ps,"   40 0 rlineto\n   0 BoxYsize 1.7 div rlineto\n   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n   0.9 setgray fill\n");
  fprintf(ps,"   stroke\n   0 -138 moveto\n   0 setgray\n   1 setlinewidth\n");
  fprintf(ps,"   40 0 rlineto\n   0 BoxYsize 1.7 div rlineto\n   -40 0 rlineto\n");
  fprintf(ps,"   closepath\n   stroke\n");
  fprintf(ps,"   50 -140 moveto\n");
  if(id == 1) fprintf(ps,"   (open reading frames derived by codaln automatic search) show\n");
  if(id == 2) fprintf(ps,"   (open reading frames after editing (group with lower priority)) show\n");
  fprintf(ps," }{}ifelse\n");
  fprintf(ps,"}bind def\n\n");
  fprintf(ps,"/cshow { %% string cshow -\n");
  fprintf(ps,"  %% show the string centered in x-direction\n");
  fprintf(ps,"  dup stringwidth\n");
  fprintf(ps,"  pop\n");
  fprintf(ps,"  2 div neg\n");
  fprintf(ps,"  1 rmoveto   %% warning: currentpoint is 1 unit higher than before\n");
  fprintf(ps,"  show\n");
  fprintf(ps,"} bind def\n\n");
  fprintf(ps,"/DrawLength {\n");
  fprintf(ps,"    380 30 moveto\n   show\n   } bind def\n\n");
  fprintf(ps,"/DrawTitle {\n");
  fprintf(ps,"  -40 30 moveto\n  show\n  } bind def\n\n");
  fprintf(ps,"/DrawSeqTitle {\n");
  fprintf(ps,"   50 0 rmoveto\n    show\n   } bind def\n\n");

  fprintf(ps,"/DrawGenome { %% length array1 array2 array3 array4 DrawGenome -\n");
  fprintf(ps,"  %% put arrays on stack into variables\n");
  fprintf(ps,"  /Frame3 exch def\n");
  fprintf(ps,"  /Frame2 exch def\n");
  fprintf(ps,"  /Frame1 exch def\n");
  fprintf(ps,"  /Exons exch def\n");
  fprintf(ps,"  %%\n");
  fprintf(ps,"  dup Xsize exch div 2 array astore\n");
  fprintf(ps,"  /Dims exch def  %% Dims =[length scale]\n");
  fprintf(ps,"  gsave\n");
  fprintf(ps,"    DrawNucs\n");
  fprintf(ps,"    DrawScale\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    0.1 ChangeGrayValue\n");
  fprintf(ps,"    Exons DrawExons\n");
  fprintf(ps,"    (Exons ) labelshow\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    Frame1 DrawExons\n");
  fprintf(ps,"    (Frame 1) labelshow\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    Frame2 DrawExons\n");
  fprintf(ps,"    (Frame 2) labelshow\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    Frame3 DrawExons\n");
  fprintf(ps,"    %%...\n");
  fprintf(ps,"    .6 ChangeGrayValue\n");
  fprintf(ps,"    (Frame 3) labelshow\n");
  fprintf(ps,"  grestore\n");
  fprintf(ps,"} bind def\n\n");

  fprintf(ps,"/DrawFound { %% length array1 array2 array3 array4 DrawFound -\n");
  fprintf(ps,"  %% put arrays on stack into variables\n");
  fprintf(ps,"  /FoundFrame3 exch def\n");
  fprintf(ps,"  /FoundFrame2 exch def\n");
  fprintf(ps,"  /FoundFrame1 exch def\n");
  fprintf(ps,"  dup Xsize exch div 2 array astore\n");
  fprintf(ps,"  /Dims exch def  %% Dims =[length scale]\n");
  fprintf(ps,"  gsave\n");
  fprintf(ps,"    0 BoxYsize 3 mul neg translate\n");
  fprintf(ps,"    0.9 ChangeGrayValue\n");
  fprintf(ps,"    FoundFrame1 DrawExFound\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    FoundFrame2 DrawExFound\n");
  fprintf(ps,"    0 BoxYsize 1.5 mul neg translate\n");
  fprintf(ps,"    FoundFrame3 DrawExFound\n");
  fprintf(ps,"    .6 ChangeGrayValue\n");
  fprintf(ps,"  grestore\n");
  fprintf(ps,"} bind def\n\n");
  
  fprintf(ps,"/DrawNucs {   %% - DrawNucs -\n");
  fprintf(ps,"  %% draw the grey box representing entire sequence\n");
  fprintf(ps,"  Dims aload pop mul\n");
  fprintf(ps,"  0\n");
  fprintf(ps,"  DrawBox\n");
  fprintf(ps,"} bind def\n\n");
  
  fprintf(ps,"/DrawBox { %% length_of_box scaled_x_coord DrawBox -\n");
  fprintf(ps,"  %% draw a box; height is taken from BoxYsize\n");
  fprintf(ps,"  newpath\n");
  fprintf(ps,"  0 moveto\n");
  fprintf(ps,"  0 -2 rmoveto\n");  
  fprintf(ps,"  0 BoxYsize rlineto\n");
  fprintf(ps,"  0 rlineto\n");
  fprintf(ps,"  0 BoxYsize neg rlineto\n");
  fprintf(ps,"  closepath\n");
  fprintf(ps,"  gsave\n");
  fprintf(ps,"    GrayValue setgray\n");
  fprintf(ps,"    fill\n");
  fprintf(ps,"  grestore\n");
  fprintf(ps,"  stroke\n");
  fprintf(ps,"} bind def\n\n");

  fprintf(ps,"/DrawFoundBox {\n");
  fprintf(ps,"  newpath\n");
  fprintf(ps,"  0 moveto\n");
  fprintf(ps,"  0 3 rmoveto\n");
  fprintf(ps,"  0 BoxYsize 1.7 div rlineto\n");
  fprintf(ps,"  0 rlineto\n");
  fprintf(ps,"  0 BoxYsize 1.7 div neg rlineto\n");
  fprintf(ps,"  closepath\n");
  fprintf(ps,"  gsave\n");
  fprintf(ps,"    GrayValue setgray\n");
  fprintf(ps,"    fill\n");
  fprintf(ps,"  grestore\n");
  fprintf(ps,"  stroke\n");
  fprintf(ps,"} bind def\n\n");
  
  fprintf(ps,"/DrawScale { %%  - Drawscale -\n");
  fprintf(ps,"  %% draw the scale above the sequence box\n");
  fprintf(ps,"  newpath\n");
  fprintf(ps,"  0 BoxYsize moveto\n");
  fprintf(ps,"  0 %% put acounter on the stack\n");
  fprintf(ps,"  CalcTickSpacing 0 exch 3 -1 roll 1.001 mul {\n");
  fprintf(ps,"    dup dup Dims 1 get mul BoxYsize moveto\n");
  fprintf(ps,"    Dims 1 get mul BoxYsize dup 3 div add lineto\n");
  fprintf(ps,"    exch dup 0 eq\n");
  fprintf(ps,"    {\n");
  fprintf(ps,"      pop 4 exch\n");
  fprintf(ps,"      0.5 add cvi 12 string cvs cshow\n");
  fprintf(ps,"    }\n");
  fprintf(ps,"    {\n");
  fprintf(ps,"    exch pop 1 sub\n");
  fprintf(ps,"    } ifelse\n");
  fprintf(ps,"  } for\n");
  fprintf(ps,"  stroke\n");
  fprintf(ps,"  pop\n");
  fprintf(ps,"} bind def\n\n");
  fprintf(ps,"/CalcTickSpacing {\n");
  fprintf(ps,"  Dims 0 get\n");
  fprintf(ps,"  dup log dup dup truncate sub\n");
  fprintf(ps,"  exch truncate exch dup\n");
  fprintf(ps,"  Log2 lt { pop } {Log5 lt {Log2 add}{Log5 add} ifelse} ifelse\n");
  fprintf(ps,"  1 sub 10 exch exp\n");
  fprintf(ps,"} bind def\n\n");
  
  fprintf(ps,"/DrawExons { %% array DrawExons - \n");
  fprintf(ps,"  %% draw the boxes for each ORF\n");
  fprintf(ps,"  aload length 2 idiv 1 exch 1 exch %% stack = array_values 1 1 length/2\n");
  fprintf(ps,"  {\n");
  fprintf(ps,"    pop  %% get rid of loop index\n");
  fprintf(ps,"    1 index sub\n");
  fprintf(ps,"    Dims 1 get\n");
  fprintf(ps,"    dup\n");
  fprintf(ps,"    4 -1 roll mul %% x *= scale\n"); 
  fprintf(ps,"    3 1 roll mul %% length *= scale\n");
  fprintf(ps,"    exch DrawBox\n");
  fprintf(ps,"  } for\n");
  fprintf(ps,"} bind def\n\n");

  fprintf(ps,"/DrawExFound {\n");
  fprintf(ps,"  aload length 2 idiv 1 exch 1 exch %% stack = array_values 1 1 length/2\n");
  fprintf(ps,"  {\n");
  fprintf(ps,"    pop  %% get rid of loop index\n");
  fprintf(ps,"    1 index sub\n");
  fprintf(ps,"    Dims 1 get\n");
  fprintf(ps,"    dup\n");
  fprintf(ps,"    4 -1 roll mul %% x *= scale\n"); 
  fprintf(ps,"    3 1 roll mul %% length *= scale\n");
  fprintf(ps,"    exch DrawFoundBox\n");
  fprintf(ps,"  } for\n");
  fprintf(ps,"} bind def\n\n");

  
  fprintf(ps,"/Helvetica findfont\n");
  fprintf(ps,"11 scalefont setfont\n");

  fprintf(ps,"  \n %% data start here\n\n");
  d=1;
  while(SEQ[a].seq){
    fprintf(ps,"%%%%Page: %hu\n", d);
    d++;
    b=0;
    while(b<5){
      if(SEQ[a].seq){
	fprintf(ps,"%% length of genome\n");
	fprintf(ps,"%i\n", SEQ[a].len);
	fprintf(ps,"%% exons\n");
	fprintf(ps,"[\n");
	while(SEQ[a].exon[c].start){
	  fprintf(ps,"%li %li\n", SEQ[a].exon[c].start, SEQ[a].exon[c].stop);
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"%% frame1\n");
	fprintf(ps,"[\n");
	while(SEQ[a].ORF[c].start){
	  if(SEQ[a].ORF[c].start%3==1){
	    fprintf(ps,"%li %li\n", SEQ[a].ORF[c].start, SEQ[a].ORF[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"%% frame2\n");
	fprintf(ps,"[\n");
	while(SEQ[a].ORF[c].start){
	  if(SEQ[a].ORF[c].start%3==2){
	    fprintf(ps,"%li %li\n", SEQ[a].ORF[c].start, SEQ[a].ORF[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"%% frame3\n");
	fprintf(ps,"[\n");
	while(SEQ[a].ORF[c].start){
	  if(SEQ[a].ORF[c].start%3==0){
	    fprintf(ps,"%li %li\n", SEQ[a].ORF[c].start, SEQ[a].ORF[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	if(!b) 	fprintf(ps,"97 Ysize 35 add translate\n");
	else fprintf(ps,"0 Ysize 5 div neg translate\n");
	fprintf(ps,"DrawGenome\n");

	fprintf(ps,"%% length of genome\n");
	fprintf(ps,"%i\n", SEQ[a].len);
	fprintf(ps,"%% found frame1\n");
	fprintf(ps,"[\n");
	while(SEQ[a].found[c].start){
	  if(SEQ[a].found[c].start%3==1){
	    fprintf(ps,"%li %li\n", SEQ[a].found[c].start, SEQ[a].found[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"%% found frame2\n");
	fprintf(ps,"[\n");
	while(SEQ[a].found[c].start){
	  if(SEQ[a].found[c].start%3==2){
	    fprintf(ps,"%li %li\n", SEQ[a].found[c].start, SEQ[a].found[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"%% found frame3\n");
	fprintf(ps,"[\n");
	while(SEQ[a].found[c].start){
	  if(SEQ[a].found[c].start%3==0){
	    fprintf(ps,"%li %li\n", SEQ[a].found[c].start, SEQ[a].found[c].stop);
	  }
	  c++;
	}
	c=0;
	fprintf(ps,"]\n");
	fprintf(ps,"DrawFound\n");
		
	fprintf(ps,"(%i bp)DrawLength\n", SEQ[a].len);
	fprintf(ps,"(file: %s)DrawTitle\n", SEQ[a].FN);
	fprintf(ps,"(> %s)DrawSeqTitle\n\n", SEQ[a].seqname);
	a++;
      }
      b++;
    }
    fprintf(ps,"legendshow\n");
    fprintf(ps,"showpage\n\n");
  }   
  fclose(ps);
}


